/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
 
dojo.provide("psm.admin.ui.internal.editors.SAContextEditorInput");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("psm.common.constants.sadmConstants");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");

dojo.requireLocalization("psm.admin.ui.internal.editors", "SAContextEditorInputMessages");
var messages = dojo.i18n.getLocalization("psm.admin.ui.internal.editors", "SAContextEditorInputMessages");

var BASIC_ACTION_PREFIX = "#action=rmps.app.settings.";
var DEFAULT_CONTEXT_PROPERTY = psm.common.constants.sadmConstants.DEFAULT_CONTEXT_PROPERTY;
/**
 * Editor input class for setting the System Architect context of a project area.
 */
dojo.declare("psm.admin.ui.internal.editors.SAContextEditorInput", [rmps.ui.editor.EditorInput], {

	projectConfigurationsInfo: null,

	constructor: function(projectConfigurationsInfo) {
		this.projectConfigurationsInfo = projectConfigurationsInfo;
	},

	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectConfigurationsInfo.projectId);
	},

	getName: function() {
		return messages.editorInputTitle;
	},

	getBasePresentationUri: function()  {
		return BASIC_ACTION_PREFIX + DEFAULT_CONTEXT_PROPERTY;
	}

});
 
})();