/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("psm.importer.ui.internal.menus.ImportAdminMenuInitializer");

dojo.require("psm.importer.ui.internal.constants.iconConstants");
dojo.require("psm.importer.ui.internal.pages.PageAccessCheck");
dojo.requireLocalization("psm.importer.ui.internal.menus", "MenuStrings");
var messages = dojo.i18n.getLocalization("psm.importer.ui.internal.menus", "MenuStrings");
var pageAccessCheck = new psm.importer.ui.internal.pages.PageAccessCheck();
var iconConstants = psm.importer.ui.internal.constants.iconConstants;
/*Add import menu items to the admin page */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminComponentMenu, "addExtendedCapabilityComponentMenuItems", {
	after: function() {
		var menu = dojox.lang.aspect.getContext().instance;
		// show the menu only when the domain "Rational System Architect Diagram Domain" is 
		// associated with the project area, and domain version is available
		if (pageAccessCheck.checkDomains()){
			menu.addTitle(messages.MENUSECTION_SA);
			menu.addItemByArgs({
				label: messages.MENUITEM_IMPORT_REQUEST,
				href: "#action=psm.importer.sa.request",
				icon: iconConstants.IMPORTREQUEST_ICON
			});
			menu.addItemByArgs({
				label: messages.MENUITEM_IMPORT_HISTORY,
				href: "#action=psm.importer.sa.history",
				icon: iconConstants.IMPORTSTATUS_ICON
			});
		}
	}
});

})();