/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("psm.importer.ui.internal.pages.ImportSAClient");

dojo.require("dojox.xml.DomParser");
dojo.require("jazz.app.context");
dojo.require("jazz.client.xhr");
dojo.require("rmps.core.RootServices");

var addErrorCallback= function(deferred){
	deferred.addErrback(this, function(error){
		if (!dojo._isDocumentOk(deferred.ioArgs.xhr)) {
			return rmps.core.error.createXhrError(deferred.ioArgs);
		}
		return rmps.core.error.createError(error);
	});
	return deferred;
};

/*Delegate some required jazz.client functions and add the required handling for errors and baseline*/
var CLIENT= {};

CLIENT.xhrPost= dojo.hitch(CLIENT, function(args){
	return addErrorCallback(jazz.client.xhrPost(args));
});

/* 
 * Provide POST operations
 * 
 */
psm.importer.ui.internal.pages.ImportSAClient = {
	importSADiagram: function(resourceXML) {
        var uri = net.jazz.ajax._contextRoot + "/SADiagramImportRequest";
        var context = jazz.app.context.get();
		if( context.baseline!==undefined ) {
			uri += '?rmps.context='+context.baseline;
			uri += '&changeSetAction=SHARE_ON_SAVE';
			uri += '&projectId='+context.itemId;
		} else {
			alert("Project is not baselined!!!");
		}
		
		var args = {
			headers: {
				"Accept" : "text/xml",
				"Content-Type" : "text/html",
				"X-ibm-rmps-internal": "true"
			},
			content: {
				data: null
			},
			url: uri,
			postData: resourceXML
		};
		return CLIENT.xhrPost(args);
	}
};

})();