/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("psm.importer.ui.internal.pages.PageAccessCheck");

dojo.require("dojox.xml.DomParser");
dojo.require("jazz.app.context");
dojo.require("jazz.client.xhr");
dojo.require("rmps.core.RootServices");
dojo.require("psm.common.constants.sadmConstants");
dojo.require("rmps.app.ui.internal.dialogs.SelectDomainVersionDialog");
var Constants = psm.common.constants.sadmConstants;
//var Context = jazz.app.context.get();

dojo.declare("psm.importer.ui.internal.pages.PageAccessCheck",null,{
	domainCheck:null,
	baselineCheck:null,
	check:function(){
		this.checkDomains();
		this.checkBaselines();
		if(this.domainCheck && this.baselineCheck)
			return true;
		else
			return false;
	},
	checkDomains: function() {
		var DOMAIN_REG_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "domainRegistry"); //$NON-NLS-1$
		rmps.core.client.xhrGet({
			url : DOMAIN_REG_PATH + "/getDomainVersions",//$NON-NLS-1$
			handleAs : 'json',//$NON-NLS-1$
			headers : {
				"Accept" : "application/json"//$NON-NLS-1$ //$NON-NLS-2$
			},
			sync : true,
			load : dojo.hitch(this, function(result) {
				var flag = false;
				dojo.some(result, function(entry1){
					if (entry1.label == Constants.SA_DOMAIN) {
						dojo.some(entry1.snapshots, function(entry2){
							if (entry2.selected){
								flag = true;
								return;
							}
						});
					}
				});
				if (flag) {
					this.domainCheck = true;
				}else{
					this.domainCheck = false;
				}
			}),
			error : function(error){
				
			}
		});
		return this.domainCheck;
	},
	checkBaselines:function(){
		if(jazz.app.context.get().baseline == undefined || jazz.app.context.get().baseline == null)
			this.baselineCheck = true;
		else if(jazz.app.context.get().baseline.indexOf("baseline")==-1) //$NON-NLS-1$
			this.baselineCheck = true;
		else
			this.baselineCheck = false;
	},
	/*
	 * get SADM now project URI 
	 */
	_getSADMProjectURI:function(){
		var URI = window.location.href;
		var splitArr = new Array();
		splitArr = URI.split("/dm/");//$NON-NLS-1$
		if(splitArr[0] != URI)
			return splitArr[0] + "/dm/web/projects/" + Context.name + "?rmps.context="+ Context.baseline+"#action=com.ibm.team.dashboard.viewDashboard";//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		else 
			return null;
	}
});

})();