/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.rational.psm.importer.temp                                     |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2012.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corporation.          |
 *+------------------------------------------------------------------------+
 */

(function() {
	/**
	 * This widget provides the entry page for SA import request
	 * 
	 * @author Xiangjun CHEN, Qi Shen, JunPing Cai, Nanqun Chen
	 */
	dojo.provide("psm.importer.ui.internal.pages.SAImportRequest");
	
	dojo.require("dojo.cache");
	dojo.require("net.jazz.ajax.ui.PlatformUI");
	dojo.require("dojo.i18n");
	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("dijit.form.Button");
	dojo.require("dojo.date.locale");
	dojo.requireLocalization("psm.importer.ui.internal.pages", "ApplicationMessages");
	dojo.requireLocalization("psm.importer.ui.internal.pages", "StandardMessages");
	dojo.require("psm.common.utils.messaging");
	dojo.require("psm.common.constants.sadmConstants");
    dojo.require("psm.importer.ui.internal.constants.iconConstants");
	dojo.require("psm.importer.ui.internal.pages.SAImportSelection");
	dojo.require("rmps.ui.CollapsibleSection");
    dojo.require("psm.importer.ui.internal.pages.ScheduleWidget");
    dojo.require("psm.importer.ui.internal.pages.ImportSAClient");
    dojo.require("rmps.core.projects.ProjectClient");
    dojo.require("psm.importer.ui.internal.pages.SnapshotWidget");
    // dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
    dojo.require("rmps.core.util.ContextUtils");
    dojo.require("psm.importer.ui.internal.pages.SACommonUtils");
	//Check the Domain and the Baseline
	dojo.require("psm.importer.ui.internal.pages.PageAccessCheck");
	var pageAccessCheck = new psm.importer.ui.internal.pages.PageAccessCheck();
	
    var messages = dojo.i18n.getLocalization("psm.importer.ui.internal.pages", "ApplicationMessages");    	
    var errorMessages = dojo.i18n.getLocalization("psm.importer.ui.internal.pages", "StandardMessages");    	
    var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var importActionButton = null;
    var requestMessageBox = new psm.common.utils.messaging();
	var ImportSAClient= psm.importer.ui.internal.pages.ImportSAClient;
	var sadmConstants = psm.common.constants.sadmConstants;
	var iconConstants = psm.importer.ui.internal.constants.iconConstants;
	var ProjectClient = rmps.core.projects.ProjectClient;
	var saCommonUtils = psm.importer.ui.internal.pages.SACommonUtils;
	var DEFAULT_CONTEXT_PROPERTY = sadmConstants.DEFAULT_CONTEXT_PROPERTY;
	var DEFAULT_WSNAME_PROPERTY = sadmConstants.DEFAULT_WSNAME_PROPERTY;
	var VVCcontextUtils = rmps.core.util.ContextUtils;
	/* Define the loading symbol image */
	var LOADING_IMG = "<img class='importLoadingImage' title='"+messages.processNow+"' alt='"+messages.processNow //$NON-NLS-1$ //$NON-NLS-2$
			+ "' src="+iconConstants.LOADING_IMG+">"+messages.processNow; //$NON-NLS-1$
	
	dojo.declare("psm.importer.ui.internal.pages.SAImportRequest", [ dijit._Widget, dijit._Templated ], {
		messages : messages,
		errorMessages : errorMessages,
		templateString : dojo.cache("psm.importer", "ui/internal/pages/templates/SAImportRequest.html"),
		diagramTypeSelectWidget:null,
		postCreate : function() {
			var context = null;
			var wsName =null
			var schedule = null;
			var snapshot = null;
		    var collapsibleSectionSelection;
		    var collapsibleSectionSchedule;
		    var collapsibleSectionSnapshot;
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("psm.importer.sa.request", this, "loadData");//$NON-NLS-1$,$NON-NLS-2$
			this._requestImportIMG.src =  iconConstants.IMPORTREQUEST_ICON;
			/*
			 * the first CollapsibleSection container named Diagram Selection
			 */
			this.collapsibleSectionSelection = new rmps.ui.CollapsibleSection();
			this.collapsibleSectionSelection.setPrimaryTitle(messages.selectionSectionTitle);
			this._replaceChildrenNodes(this.SelectionAttachPoint, this.collapsibleSectionSelection.domNode);
			/*
			 * the second CollapsibleSection container named Import Schedule
			 */
			this.collapsibleSectionSchedule = new rmps.ui.CollapsibleSection();
			this.collapsibleSectionSchedule.setPrimaryTitle(messages.scheduleSectionTitle);
			this.collapsibleSectionSchedule.toggle();
			this._replaceChildrenNodes(this.ScheduleAttachPoint,this.collapsibleSectionSchedule.domNode);
			/*
			 * the third CollapsibleSection container named Snapshot 
			 */
			this.collapsibleSectionSnapshot = new rmps.ui.CollapsibleSection();
			this.collapsibleSectionSnapshot.setPrimaryTitle(messages.snapshotSectionTitle);
			this.collapsibleSectionSnapshot.toggle();
			this._replaceChildrenNodes(this.SnapshotAttachPoint,this.collapsibleSectionSnapshot.domNode);
			
			/*
			 * add import button
			 */
			importActionButton = dojo.create("button",{id:"importActionButton",innerHTML:messages.importButton,disabled:"disabled"});//$NON-NLS-1$,$NON-NLS-2$,$NON-NLS-3$
    		this.importButton.appendChild(importActionButton);
    		/*
    		 * add loading image
    		 */
    		importLoadingImage = dojo.create("div",{id:"importLoadingImage",innerHTML:LOADING_IMG}); //$NON-NLS-1$ //$NON-NLS-2$
    		importLoadingImage.style.display = "none";//$NON-NLS-1$
    		this.importButton.appendChild(importLoadingImage);
    		
    		// initial the MessageArea on this page	
    		requestMessageBox.initialiseMessageArea(this.importRequestMessageArea);   		
    		
    		//constructor
    		this._constructor();
    		// register the "onClick" event on importButto	
			dojo.connect(importActionButton, "onclick", dojo.hitch(this,this._doImportAction));//$NON-NLS-1	
		},
		loadData : function() {
			
		},
		/*
		 * get context URI from storage area
		 */
		_constructor:function(){			
			if(!pageAccessCheck.check()){
				requestMessageBox.showMessage(this.errorMessages.request_SAResourceCreationException_summary_CRCSA10004E, jazz.ui.MessageBox.STATUS_TYPES.ERROR, 
						[{message: dojo.string.substitute(this.errorMessages.request_SAResourceCreationException_details_CRCSA10004E, {line_separator:"</br>"})}], null, -1);
				return;
			}
			var projectId = jazz.app.context.get().itemId;
			var getPropertyDeferred = ProjectClient.getProjectProperty(projectId, DEFAULT_CONTEXT_PROPERTY);
			getPropertyDeferred.addCallback(this,function(propertyValue){
				context = propertyValue;
				var getWsNameDeferred = ProjectClient.getProjectProperty(projectId, DEFAULT_WSNAME_PROPERTY);
				getWsNameDeferred.addCallback(this,function(wsNameValue){
					wsName = wsNameValue;
					this._validateURI(context, wsName);
				});
			});
			getPropertyDeferred.addErrback(this, function(propertyValue){
				
	    		var linkstr = this._getLinkStr();
	    		requestMessageBox.showMessage(this.errorMessages.request_contextNotSetMessage_summary_CRCSA10001E, jazz.ui.MessageBox.STATUS_TYPES.ERROR, 
						[{message: dojo.string.substitute(this.errorMessages.request_contextNotSetMessage_details_CRCSA10001E,{appAdminLink:linkstr})}], null, -1);
			});
		},
		/*
		 * validate the context URI
		 */
		_validateURI:function(contextURI, wsName){
    		var server_uri =  contextURI;
    		var linkstr = this._getLinkStr();
			this._getRDFFromSA(false, server_uri, dojo.hitch(this, function(result){
				if(!result){
					requestMessageBox.showMessage(this.errorMessages.request_contextErrormessage_summary_CRCSA10002E, jazz.ui.MessageBox.STATUS_TYPES.ERROR, 
							[{message: dojo.string.substitute(this.errorMessages.request_contextErrormessage_details_CRCSA10002E,{serverLink:wsName,appAdminLink:linkstr})}], null, -1);

				}else{
					this._validateSAPermission(contextURI);
					this._replaceChildrenNodes(this.connectionInfoAttachPoint,this._createConnectionInfo(wsName));
					this._generateDiagramTypesSelectWidget(contextURI);
					this._getSchedule();
					this._getSnapshot();
				}
        	}), dojo.hitch(this, function(){
        		requestMessageBox.showMessage(this.errorMessages.request_contextErrormessage_summary_CRCSA10002E, jazz.ui.MessageBox.STATUS_TYPES.ERROR, 
						[{message: dojo.string.substitute(this.errorMessages.request_contextErrormessage_details_CRCSA10002E,{serverLink:wsName,appAdminLink:linkstr})}], null, -1);
        	})); 
		},
		
		_validateSAPermission:function(contextURI){
			var server_uri = contextURI+"/Diagrams?hasInstances=true";//$NON-NLS-1$
			jazz.client.xhrGet({
	        	url: server_uri,	        	
	        	handleAs: "xml", //$NON-NLS-1$
	        	sync:true,
	        	load: dojo.hitch(this,function(result){
	        		if(!result){
						return;
					}
					var diagramTypeList = saCommonUtils.parseDiagramTypesOrInstances(result);
					if(diagramTypeList.length==0){
						requestMessageBox.showMessage(this.errorMessages.request_SAEncylopediaAccessDenied_summary_CRCSA10003W,jazz.ui.MessageBox.STATUS_TYPES.WARNING,
								[{message:this.errorMessages.request_SAEncylopediaAccessDenied_details_CRCSA10003W}],null,-1);
					}
	        	}),
	        	error: dojo.hitch(this, function(error) {
				})
	        });
		},
		
		_getRDFFromSA:function(syncstatus, serverUri, callback, errback){
			jazz.client.xhrGet({
	        	url: serverUri,	
	        	sync:syncstatus,
	        	handleAs: "xml",
	        	load: callback,
	        	error: errback,
	        	timeout: 5000,
	       });
		},
		/**
		 * add snapshot section to collapsibleSection container
		 */
		_getSnapshot:function(){
			snapshot = new psm.importer.ui.internal.pages.SnapshotWidget();
			this._replaceChildrenNodes(this.collapsibleSectionSnapshot.containerNode,snapshot.domNode);//add the schedule to CollapsibleSection container
	
		},
		/**
		 * add schedule section to CollapsibleSection container
		 */
		_getSchedule:function(){
			schedule = new psm.importer.ui.internal.pages.ScheduleWidget();
			this._replaceChildrenNodes(this.collapsibleSectionSchedule.containerNode,schedule.domNode);//add the schedule to CollapsibleSection container
					
		},
		/**
		 * generate DiagramTypesGrid when user select "Import Diagrams from selected Diagram types"
		 */
		_generateDiagramTypesSelectWidget : function(serverUri){
			this.diagramTypeSelectWidget = new psm.importer.ui.internal.pages.SAImportSelection({serverUri:serverUri, button:importActionButton});
			this._replaceChildrenNodes(this.collapsibleSectionSelection.containerNode,this.diagramTypeSelectWidget.domNode);//add the diagramTypeSelectWidget to CollapsibleSection container
		},
		/**
		 * Create the connection information in the request page
		 */
		_createConnectionInfo:function(serverUri){
			var connectionInfo = dojo.create("div",{"class":"sa-import-request-connectDiv",innerHTML :"<label class='sa-import-request-connectLabel'>"+messages.connectionInformation+"</label>"});//$NON-NLS-1$
			var uriInfo = dojo.create("span",{innerHTML :serverUri});//$NON-NLS-1$
			connectionInfo.appendChild(uriInfo);
			return connectionInfo;
			
		},
		/**
		 * Import function interface 
		 */
		_doImportAction : function(){
			requestMessageBox.hideMessage();	
			var requestXML = this._generatePostXML();
			if(requestXML){
				importLoadingImage.style.display = "inline-block";//$NON-NLS-1$
				importActionButton.disabled = true;
				var importDeferred = ImportSAClient.importSADiagram(requestXML);
				importDeferred.addCallback(dojo.hitch(this, function(result) {
					importLoadingImage.style.display = "none";//$NON-NLS-1$
					importActionButton.disabled = false;
					if(result){	
						var link = window.location.href;
						link = link.replace(new RegExp("request"), "history");//$NON-NLS-1$ //$NON-NLS-2$
						requestMessageBox.showMessage(messages.importTaskAddedmessage + "&nbsp;&nbsp;<a href='"+link+"'>"+messages.historyViewLink+"</a>", 
								jazz.ui.MessageBox.OK, null, null, -1);
						dojo.body().scrollIntoView();
					}else{
						return ;
					}				
				}));
				importDeferred.addErrback(dojo.hitch(this, function(error, ioArgs) {
					importLoadingImage.style.display = "none";//$NON-NLS-1$
					importActionButton.disabled = false;
					if(error.message.toUpperCase().indexOf(sadmConstants.SA_PERMISSIONDENIED) >= 0)
						requestMessageBox.showMessage(errorMessages.request_importPermissionDenied_summary_CRCSA10005E, jazz.ui.MessageBox.STATUS_TYPES.ERROR,
								[{message: errorMessages.request_importPermissionDenied_details_CRCSA10005E}]);
					else
						requestMessageBox.showMessage(error.message, jazz.ui.MessageBox.STATUS_TYPES.ERROR);
					dojo.body().scrollIntoView();
				}));
			}
			
		},
		_replaceChildrenNodes: function( parent , child) {
			dojo.empty(parent);//remove the child node from parent node
			parent.appendChild(child);//add the new child node
		},
		
		/*
		 * get SADM now server URI 
		 */
		_getSADMServerURI:function(){
			var URI = window.location.href;
			var splitArr = new Array();
			splitArr = URI.split("/dm/");//$NON-NLS-1$
			if(splitArr[0] != URI)
				return splitArr[0] + "/";
			else 
				return null;
		},
		
		/**
		 *  the snapshot name which user input is valid or not
		 */
		isSnapshotInputValid:function(){
			var flag = true;
			var isSnapshot = snapshot.getIsSnapshot();
			var scheduleMode = schedule.getRepeatMode();
			var snapshotName = snapshot.getSnapshotName();
			if(isSnapshot){
				if(scheduleMode != sadmConstants.SA_IMPORT_SCHEDULE_REPEAT_OFF && snapshotName.indexOf(sadmConstants.CREATED_VARIABLE) == -1){
					flag = false;
				}
			}			
			return flag;
			
		},
		
		_getLinkStr:function(){
			var projectId = jazz.app.context.get().itemId;
    		var linkstr = "<a href='"+this._getSADMServerURI()+"dm/admin#action=com.ibm.team.process.editProjectArea" + //$NON-NLS-1$//$NON-NLS-2$
			"&itemId="+projectId+"'>"+ this.errorMessages.contextSetlink+"</a>";//$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$
    		return linkstr;
		},
		/**
		 * judge that snapshot exist in vvc server or not
		 */
		_isSnapshotNameExist:function(snapshotName){
			var flag = false;
			var isSnapshot = snapshot.getIsSnapshot();
			if(isSnapshot){
				if(snapshotName.indexOf(sadmConstants.CREATED_VARIABLE) == -1){
					var spaceUri = VVCcontextUtils.spaceUri;
					var vvcRoot = VVCcontextUtils._rootVvcUri;
					var mutable = false;
					var uri = vvcRoot + "/repository/findSnapshotName?configurationName=" + snapshotName +//$NON-NLS-1$
							"&spaceUri=" + spaceUri +		//$NON-NLS-1$
							"&mutable=" + mutable;			//$NON-NLS-1$
					var args = {
							url: uri,
							headers: {
								"Accept" : "application/json"	//$NON-NLS-1$
							},
							sync: true,
							handleAs: "text",//$NON-NLS-1$
							load: function(response, ioArgs) {
								if (ioArgs) {
									var xhr = ioArgs.xhr;
									if (xhr) {
										if(xhr.getResponseHeader("Location")){										
											flag = true;
										}
									}
								}
							},
						};
					deferred = jazz.client.xhrGet(args);				
				}
			}
			
			return flag;
		},
		
		/**
		 *  generate the post xml
		 */
		_generatePostXML:function(){
			var typesAndInstancesXml = this.diagramTypeSelectWidget.getSelectedTypesAndInstancesXML();			
			var scheduleMode = schedule.getRepeatMode();
			var repeatDays = sadmConstants.SA_IMPORT_DEFAULT_REPEAT_DAYS;
			var repeatTime = sadmConstants.SA_IMPORT_DEFAULT_REPEAT_TIME;			
			// SA connection context
			var serverUri = context;
			if(!schedule.isInputValid()){
				requestMessageBox.showMessage(errorMessages.request_ScheduleTimeError_summary_CRCSA10006E, jazz.ui.MessageBox.STATUS_TYPES.ERROR,
						[{message: dojo.string.substitute(errorMessages.request_ScheduleTimeError_details_CRCSA10006E, {line_separator:"</br>"})}]);
				dojo.body().scrollIntoView();
				return;
			}
			if(!this.isSnapshotInputValid()){
				requestMessageBox.showMessage(errorMessages.request_SnapshotNameError_summary_CRCSA10010E, jazz.ui.MessageBox.STATUS_TYPES.ERROR,
						[{message: errorMessages.request_SnapshotNameError_details_CRCSA10010E}]);
				dojo.body().scrollIntoView();
				return;
			}
			if(this._isSnapshotNameExist(snapshot.getSnapshotName())){
				requestMessageBox.showMessage(errorMessages.request_SnapshotNameExistError_summary_CRCSA10011E, jazz.ui.MessageBox.STATUS_TYPES.ERROR,
						[{message: errorMessages.request_SnapshotNameExistError_details_CRCSA10011E}]);
				dojo.body().scrollIntoView();
				return;
			}
			
			switch(scheduleMode){
				case  sadmConstants.SA_IMPORT_SCHEDULE_REPREAT_INTERVAL:
					repeatTime = schedule.getRepeatInputTime();
					break;
				case sadmConstants.SA_IMPORT_SCHEDULE_REPEAT_WEEKLY:
					var repeatDaysArray = parseInt(schedule.getRepeatDays()).toString(2).split("").reverse();
					if(repeatDaysArray.length < 7){
						var len = repeatDaysArray.length;
						for(;len < 7;len ++){
							repeatDaysArray.push("0");
						}
					}
					repeatDays = repeatDaysArray.join("");	//$NON-NLS-1$		
					repeatTime = schedule.getRepeatTime();
					break;
				default:
					break;
			}
			
			var requestXML = "<request saContext=\"" + serverUri + "\""+//$NON-NLS-1$
			    " wsName=\"" + wsName + "\"" + //$NON-NLS-1$
				" schedule=\"" + scheduleMode + "\"" + //$NON-NLS-1$
				" repeatDays=\"" + repeatDays + "\"" + //$NON-NLS-1$
				" snapshotName=\"" + snapshot.getSnapshotName() + "\"" +//$NON-NLS-1$
				" snapshotDescription=\"" + snapshot.getSnapshotDescription() + "\"" +//$NON-NLS-1$
				" repeatTime=\"" + repeatTime + "\">" + //$NON-NLS-1$
						typesAndInstancesXml+ 
				"</request>";//$NON-NLS-1$
			
			return requestXML;
		}
	});
})();
