/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.rational.psm.importer.temp                                     |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2012.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corporation.          |
 *+------------------------------------------------------------------------+
 */

(function() {
	/**
	 * This widget provides snapshot section for SA import request
	 * 
	 * @author Kai Dong
	 */
	dojo.provide("psm.importer.ui.internal.pages.SnapshotWidget");
	dojo.require("dojo.cache");
	dojo.require("dojo.i18n");
	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	dojo.require("dijit.form.ValidationTextBox");
	dojo.require("psm.common.constants.sadmConstants");
	dojo.require("dijit.form.CheckBox");
	dojo.requireLocalization("psm.importer.ui.internal.pages", "ApplicationMessages");
	var messages = dojo.i18n.getLocalization("psm.importer.ui.internal.pages", "ApplicationMessages");
	var sadmConstants = psm.common.constants.sadmConstants;
	dojo.declare("psm.importer.ui.internal.pages.SnapshotWidget", [ dijit._Widget, dijit._Templated ], {
		messages : messages,
		templateString : dojo.cache("psm.importer", "ui/internal/pages/templates/SnapshotWidget.html"),
		constructor : function() {
			this.isCreateSnapshotCheckBox = null;
			this.snapshotNameInputBox = null;
		},

		postCreate : function() {
			this._init();
			dojo.connect(this.createSnapshotOrNot, "onclick", dojo.hitch(this, this.enableOrDisableWidget)); //$NON-NLS-1$	

		},
		
		/**
		 * initial this widget
		 */
		_init : function() {
			this.isCreateSnapshotCheckBox = new dijit.form.CheckBox();
			this.createSnapshotOrNot.appendChild(this.isCreateSnapshotCheckBox.domNode);
			this.snapshotInputText=new dijit.form.ValidationTextBox({
				regExp : "[^\\\\]+", //$NON-NLS-1$
				value : sadmConstants.CREATED_VARIABLE,//$NON-NLS-1$
				Class : "snapshotinputClass",//$NON-NLS-1$
				invalidMessage : messages.snapshotInvalidMessage,
			});
			this.snapshotInputName.appendChild(this.snapshotInputText.domNode);
			this.snapshotInputText.setDisabled(true);
			this.snapshotInputDescriptions.disabled = true;
			this._help = [];
			this._help.push(new jazz.app.ua.TextHoverHelp({helpContentString: messages.snapshotNameHelpMessage, contentNode:this.snpashotName_Help }));
		},
		/**
		 * the logic method to enable or disable the input widget and the textarea widget
		 */
		enableOrDisableWidget:function(){
			if(this.isCreateSnapshotCheckBox.checked){
				this.snapshotInputText.setDisabled(false);
				this.snapshotInputDescriptions.disabled = false;
			}else{
				this.snapshotInputText.setDisabled(true);
				this.snapshotInputDescriptions.disabled = true;
			}
		},
		/**
		 * get and return  the snapshot name
		 */
		getSnapshotName:function(){
			if(this.getIsSnapshot()){
				if(this.snapshotInputText.value!=null)
					return this.snapshotInputText.value;
			}
			return "";//$NON-NLS-1$
		},
		/**
		 * get and return the snapshot descriptions
		 */
		getSnapshotDescription:function(){
			if(this.getIsSnapshot()){
				return this.snapshotInputDescriptions.value;
			}
			return "";//$NON-NLS-1$
		},
				
		/**
		 * return user choose the snapshot checkbox or not
		 * if user choose the checkbox then return 1;
		 * if not then return 0;
		 */
		getIsSnapshot:function(){
			if(this.isCreateSnapshotCheckBox.checked){
				return true;
			}else{
				return false;
				
			}
			
		},

	});
})();
