/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){

dojo.provide("psm.admin.ui.internal.pages.SystemArchitectConfigurationFragment");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.requireLocalization("psm.admin.ui.internal.pages", "SystemArchitectConfigurationFragmentMessages");
var messages= dojo.i18n.getLocalization("psm.admin.ui.internal.pages", "SystemArchitectConfigurationFragmentMessages");//$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("psm.admin.ui.internal.pages.SystemArchitectConfigurationFragment", [dijit._Widget, dijit._Templated], {

	templateString: dojo.cache('psm.admin', 'ui/internal/pages/templates/SystemArchitectConfigurationFragment.html'),//$NON-NLS-1$ //$NON-NLS-2$
	//local copy for use in template string
	messages: messages,
	//mixin properties
	contextSelected: null, //function; called when a new context is selected from the dialog, or when the context is cleared
	errorCallback: null, //function; called when an error occurred
    projectConfigurationsInfo: null,
	contextUrl: null,
	
	setContext: function(contextUrl,wsName) {
		if (!contextUrl) {
			this.updateLabel(undefined,null);
			return;
		}
		
        //load the context object to get the name
		this.updateLabel(contextUrl,wsName);
	},
	
	_contextSelected: function(contextObject,wsName) {
		this.setContext(contextObject,wsName);
		this.contextSelected(contextObject,wsName);
	},
	
	/**
	 * Method called when the user clicks on the "edit" link - makes the editor editable
	 */				
	modify: function(url,wsName) {
       this._contextSelected(url,wsName);
	},
	
	clear: function() {
		this._contextSelected(null,null);
	},
	
	/**
	 * Updates the label with the name of the currently selected context.
	 * labelText - String, the new label text - required
	 */
	updateLabel: function(labelText,wsName) {
		dojo.empty(this._contextLabel);
		if(labelText) {
			this._contextLabel.appendChild(dojo.doc.createTextNode(wsName));
			this._contextLabel.id=wsName;
		}
		else { 
			this.updateLabel(messages.contextNotSetLabel, messages.contextNotSetLabel);
		}
	}

});

})();

