/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.rational.psm.sadiagram.web                                     |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2012.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corporation.          |
 *+------------------------------------------------------------------------+
 */

(function(){
	/**
	 * This widget provides a custom checkbox with three status
	 * 	checked,unchecked, mixed
	 * 
	 * @author Kai Dong
	 */
	dojo.provide("psm.importer.ui.internal.widget.checkboxtree.CheckBox");
	dojo.require("dijit.form.CheckBox");
	dojo.declare( "psm.importer.ui.internal.widget.checkboxtree.CheckBox",dijit.form.CheckBox,{

		baseClass:"sadmCheckBox",//$NON-NLS-1$
		value: "unchecked",//$NON-NLS-1$
		

		/**
		*	overwrite method of dijit._CssStateMixin
		*	generate the appropriate CSS classes depending on the current state of the checkbox.
		*	this will be update dom node's class
		**/
		_setStateClass: function(){
			var newStateClasses = this.baseClass.split(" ");
			var basicClasses = "dijit dijitInline dijitReset";//$NON-NLS-1$
			//return three classes newStateClasses,newStateClasses+modifier, "dijit"+modifier
			function multiply(modifier){
				newStateClasses = newStateClasses.concat(dojo.map(newStateClasses,
					function(classState){ return classState + modifier; }),"dijit" + modifier);//$NON-NLS-1$
			}
			switch(this.value){
				case "mixed"://$NON-NLS-1$
					multiply("Mixed");//$NON-NLS-1$
					break;
				case "checked"://$NON-NLS-1$
					multiply("Checked");//$NON-NLS-1$
					break;
			}			
			if(this.hovering){
				multiply(this.stateModifier+"Hover");//$NON-NLS-1$
			}
            // For performance concerns we only write into domNode.className once.
			var tn = this.stateNode || this.domNode,
                        classHash = {}; 
            //add basicClasses in className
            dojo.forEach(basicClasses.split(" "), function(c){		            	
		            	classHash[c] = true;		            	
            		});
            //add newStateClasses
            dojo.forEach(newStateClasses, function(c){ classHash[c] = true; });
			var newClasses = [];
			for(var c in classHash){
				newClasses.push(c);
			}
			tn.className = newClasses.join(" ");
			this._stateClasses = newStateClasses;
		},

		/**
		*	in Tree Node ,this method will be called by _setCheckedState in Tree_Node
		*	@param checked ,the checkbox is checked or not
		*	@param mixed , the checkbox is mixed or not
		**/
		_setCheckedState:function( checked, mixed){
			if(mixed){
				this.set("value","mixed");//$NON-NLS-1$ $NON-NLS-2$
			}else if(checked){
				this.set("value","checked");//$NON-NLS-1$ $NON-NLS-2$
			}else{
				this.set("value","unchecked");//$NON-NLS-1$ $NON-NLS-2$
			}
			this.checked = checked;
			this._setStateClass();
		},

		/**
		*	overwrite _setValueAttr method,in order to be able to use 
		*	the checkbox value attribute to hold mixed state.
		*	@param newValue
		**/
		_setValueAttr: function( newValue){			
			if (typeof newValue == 'string') {//$NON-NLS-1$
				this.value = newValue;
				this.focusNode.setAttribute("value",newValue);//$NON-NLS-1$
			}
		},

		/**
		*	overwrite _getValueAttr method
		**/
		_getValueAttr: function(){
			return this.value;
		}

		
	});
})();