/*******************************************************************************
 * Licensed Materials - Property of IBM Copyright IBM Corp. 2011, 2012. All
 * Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/

(function() {
	dojo.provide("psm.common.utils.timedEvent");
	psm.common.utils.timedEvent = {


		/***********************************************************************
		 * Execute the action after the delay specified.
		 * 
		 * @param  args.action - The function to perform when the timer ends 
		 * @param  args.delay - The time delay to wait, before performing the action (ms)
		 **********************************************************************/
		runTimedEvent: function(action, delay)
		{
			//Create a deferred and set it to fire after the given delay
			var deferred = new dojo.Deferred();
			setTimeout(function() {
				deferred.callback({
					called: true
				});
			}, delay);

			//Add a callback that performs the given action
			deferred.then(function(){
				action();
			});

			// Return the deferred, in case it's wanted.
			return deferred;
		},
	};
})();			